#include "BaseRenderable.h"
#include "Renderable2d.h"
#include "LayerManager.h"
#include "WindowMapping.h"
#include "LayerVariable.h"

// [WODE] caught this - it was in the wrong place.
int BaseRenderable::lastID = 0;

BaseRenderable::BaseRenderable(int typeID)
{
	m_bitmapBits = NULL;
	m_Texture = 0;

	ParentLayer = NULL;

	//set unique id for this session.
	id = ++lastID;
	m_typeID = typeID;
}

void BaseRenderable::InitializeBase()
{
	m_layerManager = LayerManager::m_Manager;

	m_variableCount = 0;
	SetVariables();

	delete[] m_bitmapBits;
	m_bitmapBits = NULL;
	
	//generate textures
	glGenTextures(1, &m_Texture);

	m_bitmapBits = new GLubyte[m_layerManager->m_width * m_layerManager->m_height];

	this->Initialize();
}

BaseRenderable::~BaseRenderable(void)
{
	glDeleteTextures(1, &m_Texture);
	delete [] m_bitmapBits;
}


void BaseRenderable::Translate(float delta_x, float delta_y)
{
	m_transform.Translation.x += delta_x / m_transform.Scale.x;
	m_transform.Translation.y -= delta_y / m_transform.Scale.y;
}


void BaseRenderable::Scale(float x, float y)
{
	float s_x = 1.0f - x;
	float s_y = 1.0f - y;
	assert(s_x > 0);
	assert(s_y > 0);

	m_transform.Scale.x *= s_x;
	m_transform.Scale.y *= s_y;
}

void BaseRenderable::AssignLayerToVariable(int variableIndex, Renderable2d* subLayer)
{
	if(variableIndex >= 0 && variableIndex < m_variableCount)
	{
		//link the sublayer's parent to this layer.
		m_layerVariables[variableIndex].SetRenderable(subLayer);
	}
}

void BaseRenderable::ChangeParameter(int variableIndex, float newParameter)
{
	if(variableIndex < m_variableCount)
	{
		m_layerVariables[variableIndex].SetValue(newParameter);
	}
}

void BaseRenderable::IncrementParameter(int variableIndex, float deltacutoff)
{
	ChangeParameter(variableIndex, m_layerVariables[variableIndex].GetOverrideValue() + deltacutoff);
}