#pragma once

#include <utils.h>
#include "LayerManager.h"
#include "Vector3d.h"
#include "Camera.h"

enum mouse_action_state
{
	MOUSE_INACTIVE,
	MOUSE_PANNING,
	MOUSE_ZOOMING,
	MOUSE_CUTOFF
};

class ProgramManager
{
public:
	ProgramManager(void);

	int Run(int argc, char **argv);
	~ProgramManager(void);
private:
	static ProgramManager* m_Manager;

	int m_window_id;

	Camera* theCamera;


	void static mousebutton(int button, int state, int x, int y);
	void static mousemove(int x, int y);
	void static myGlutKeyboard(unsigned char key, int x, int y);

	void doMouseMove(int x, int y);
	mouse_action_state m_MouseState;
	int mousedown_x, mousedown_y;

	void PanMouse(int delta_x, int delta_y);
	void ZoomMouse(int delta_x, int delta_y);

	void static tick(int value);
	void static display(void);
	void static reshape(int w, int h);

	int width, height;

	void SetCamera();
	void EnableLighting(bool enable);


	//menus
	void static menu_Reset(int value);
	void static menu_AddLayer(int value);

	LayerManager m_layerManager;

	GLUI_EditText *m_logEdit;
};