#pragma once

#include <utils.h>
#include "WindowMapping.h"
#include "LayerVariable.h"
#include "RenderableFactory.h"

#include "BaseRenderable.h"

class Renderable2d : public BaseRenderable
{
public:
	Renderable2d(int TypeID);
	~Renderable2d(void);

	virtual void SaveToXml(TiXmlElement *currentElement);
	virtual void LoadFromXml(TiXmlElement *currentElement);

	virtual void Initialize();

	virtual void Render();
	virtual void Update();

	float GetValueAt(float x, float y);

	bool m_inverse;

protected:

	virtual float GetRawValueAt(float x, float y) = 0;

	void WriteBitmap();
};