#include "Renderable3d.h"

Renderable3d::Renderable3d(int typeID) : BaseRenderable(typeID)
{
	m_entityCollectionCount = 0;
}

Renderable3d::~Renderable3d(void)
{
}

void Renderable3d::Render()
{
	//ONLY draw, ffs.
    glClearColor (0.5,0.5,0.6,1.0);
    glClear (GL_COLOR_BUFFER_BIT);
    
	glBindTexture(GL_TEXTURE_2D, m_Texture);
	for(int i = 0; i < m_entityCollectionCount; i++)
	{
		m_entityCollection[i].Render();
	}
}

void Renderable3d::Update()
{
	//set texture
	glBindTexture(GL_TEXTURE_2D, m_Texture);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);	// Linear Min Filter
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);	// Linear Mag Filter

	GLubyte gray[3] = {0x88, 00, 00}; //boring red colors
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 1, 1, 0, GL_RGB, GL_UNSIGNED_BYTE, &gray);

	//building collection - iterate over space
	BuildCollection();

}

void Renderable3d::Initialize()
{
}